#include "LCD.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define CURSORLEFT 'S' - 0x40
#define CURSORRIGHT 'D' - 0x40
#define CURSORUP 'E' - 0x40
#define CURSORDOWN 'X' - 0x40

extern	uchar	GetKey(void);

/**********************************************************************
*
*	uchar	LCDEnterString(uchar * szCaption,uchar * szStr,uint MaxSize)
*	String eingabe in szStr
*	return:
*		0 = Abbruch
*		1 = angenommen
*
***********************************************************************/

uchar	LCDEnterString(uchar * szCaption,uchar * szStr,uint uiMaxSize)
{
	uchar	*pbPtr,ch;
	uint	uiXPixel,x,n;
	uint	uiXCursor,uiLeftPos;
	uchar	szWorkStr[41];

	// speicher allocieren
	if ((pbPtr = (uchar*)malloc(BYTESPERLINE * MAXY)) == 0) return(0);
	// screen inhalt wegspeichern
	LCDPushFrame(0,0,MAXX,MAXY,pbPtr);

	// anzahl der Pixel berechen
	uiXPixel = (uiMaxSize+2) * CHARWIDTH;

	// frame loeschen
	LCDClearFrame(CENTERX-(uiXPixel/2),CENTERY-((5*CHARHEIGHT)/2),CENTERX+(uiXPixel/2),CENTERY+((5*CHARHEIGHT)/2));

	// rahmen zeichnen
	LCDDrawFrame((int)uiXPixel,(int)CHARHEIGHT*5,0);

	// ueberschrift ausgeben
	LCDCenterStrout(CENTERY-(2*CHARHEIGHT),szCaption);
	// vorhandenen Text ausgeben
	uiLeftPos = CENTERX-uiXPixel/2+CHARWIDTH;
	x = uiLeftPos;
	memset(szWorkStr,0,sizeof(szWorkStr));
	strcpy(szWorkStr,szStr);

	for(n=0;n < uiMaxSize;n++)
	{
		LCDCharOut(x,CENTERY-(int)CHARHEIGHT,szWorkStr[n]);
		x+=PIXELPERBYTE;
	}


	uiXCursor = 0;
	LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY,'^');
	for(;;)
	{
		ch = GetKey();
		switch(ch){
		case CR: 
			// alten bildschirminhalt wieder herstellen
			LCDPopFrame(0,0,MAXX,MAXY,pbPtr);
			strcpy(szStr,szWorkStr);
			free(pbPtr);
			return(1);
		case ESC:
			// alten bildschirminhalt wieder herstellen
			LCDPopFrame(0,0,MAXX,MAXY,pbPtr);
			free(pbPtr);
			return(0);
		case CURSORUP:
			if(szWorkStr[uiXCursor] < 127)	szWorkStr[uiXCursor]++;
			if(szWorkStr[uiXCursor] == 127) szWorkStr[uiXCursor] = 0;
			if(szWorkStr[uiXCursor] == 1)   szWorkStr[uiXCursor] = ' ';
			LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY-CHARHEIGHT,szWorkStr[uiXCursor]);
			break;
		case CURSORDOWN:
			if(szWorkStr[uiXCursor] > 0x1F)	szWorkStr[uiXCursor]--;
			if(szWorkStr[uiXCursor] == 0x1f)szWorkStr[uiXCursor] = 0;
			if(szWorkStr[uiXCursor] == 255) szWorkStr[uiXCursor] = 126;
			LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY-CHARHEIGHT,szWorkStr[uiXCursor]);
			break;
		case CURSORLEFT:
			if(uiXCursor > 0) 
			{
				LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY,' ');
				uiXCursor--;
				LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY,'^');
			}
			break;
		case CURSORRIGHT:
			if(uiXCursor < (uiMaxSize-1))
			{
				LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY,' ');
				uiXCursor++;
				LCDCharOut((uchar)(uiXCursor*CHARWIDTH+uiLeftPos),CENTERY,'^');
			}
			break;
		}
	}
	free(pbPtr);
	return(0);
}

