#include "LCD.H"


extern	uchar	ucLCDInversFlag;
extern	code	uchar	pbLCDCharSet6X8[];

/*********************************************************************
*
*	void LCDCharOut(uchar x,uchar y,uchar *Ch)
*	ein zeichen im 6x8 Font auf dem Display ausgeben
*	an der Stelle x,y
*	in Ch das zeichen
*
*********************************************************************/
void	LCDCharOut(uchar x,uchar y,uchar Ch)
{
	uint	Addr,DW,ClearWord;
	uchar	Line,*PatPtr,DB1,DB2,SF;

	Addr = ((uint)y * BYTESPERLINE) + ((uint)x /  PIXELPERBYTE) + GRAPHICHOMEADDR;
	SF = 6 - (x % PIXELPERBYTE);
	PatPtr = (uchar*)&pbLCDCharSet6X8[(uint)Ch*8];
	ClearWord = 0x003f << SF;
	ClearWord = ~ClearWord;

	for(Line=0;Line < 8;Line++,Addr+=BYTESPERLINE,PatPtr++)
	{
		// 2 Datenbytes lesen
		LCDWriteWord(WRITEADDR,Addr);
		DB1 = LCDReadByte(DATAREADINC);
		if (x < (MAXX-PIXELPERBYTE)) DB2 = LCDReadByte(DATAREADINC);
		else					     DB2 = 0;
		DW = ((uint)(DB1 & 0x3f) << 6) | ((uint)(DB2 & 0x3f)) ;
		DW &= ClearWord;

		if (ucLCDInversFlag)
			DW |= ((uint)(*PatPtr ^ 0x3f)) << SF;
		else
			DW |= ((uint)*PatPtr) << SF;

		// 2 Datenbytes schreiben
		DB2 = (uchar)(DW & 0x003f);
		DB1 = (uchar)((DW >> 6) & 0x3f);
		LCDWriteWord(WRITEADDR,Addr);
		LCDWriteByte(DATAWRITEINC,DB1);
		if (x < (MAXX-PIXELPERBYTE))
			LCDWriteByte(DATAWRITEINC,DB2);
	
	} 
}

