#include "LCD.h"

extern	const	uchar	ucLCDPatTab1[];
extern	const	uchar	ucLCDPatTab2[];
extern	const	uchar	ucLCDPatTab3[];

/*********************************************************************
*
*	void	LCDDrawLine(uchar Mode,uchar x0,uchar y0,uchar x1,uchar y1)
*	eine strecke von x0,y0 -- x1,y1 zeichen
*
*********************************************************************/
void	LCDDrawLine(uchar Mode,uchar x0,uchar y0,uchar x1,uchar y1)
{
	uchar	dx,dy,dz,i;
	uint	Addr;
	uchar	Pattern,Mod1,Mod2;

	// horizontale linie schnellere version
	if (y0 == y1 )
	{
		if (x0 > x1) dx = x0 - x1;
		else	     dx = x1 - x0;

		if (dx >= 6)
		{
			if (x0 > x1)
			{
				dz = x0;
				x0 = x1;
				x1 = dz;
			}

			Mod1 = x0 % PIXELPERBYTE;
			Mod2 = x1 % PIXELPERBYTE;
		
			// anfang der strecke zeichnen	
			if (Mod1 > 0)
			{
				LCDWriteWord(WRITEADDR,y0 * BYTESPERLINE + x0 / PIXELPERBYTE + GRAPHICHOMEADDR);
				Pattern = LCDReadByte(DATAREAD);
				if (Mode == LCDSET)
					Pattern |= ucLCDPatTab1[Mod1];
				else	Pattern &= (ucLCDPatTab1[Mod1] ^ 0xff );
				LCDWriteByte(DATAWRITEINC,Pattern);
				x0 += (PIXELPERBYTE-Mod1);
			}
			// ende der strecke zeichnen
			if (Mod2 > 0)
			{
				LCDWriteWord(WRITEADDR,y0 * BYTESPERLINE + x1 / PIXELPERBYTE + GRAPHICHOMEADDR);
				Pattern = LCDReadByte(DATAREAD);
				if (Mode == LCDSET)
					Pattern |= ucLCDPatTab2[Mod2];
				else	Pattern &= (ucLCDPatTab2[Mod2] ^ 0xff );
				LCDWriteByte(DATAWRITEINC,Pattern);
				x1 -= Mod2;
			}
			// mittelteil der strecke zeichnen
			dx = (x1 - x0) / PIXELPERBYTE;
			LCDWriteWord(WRITEADDR,y0 * BYTESPERLINE + x0 / PIXELPERBYTE + GRAPHICHOMEADDR);
			if (Mode == LCDSET)
			{
				for(i=0;i < dx;i++)
					LCDWriteByte(DATAWRITEINC,0x3f);
			} else
			{
				for(i=0;i < dx;i++)
					LCDWriteByte(DATAWRITEINC,0x00);
			}
			return;
		}					
	}  

	if (x0 == x1)		// vertikale linie schnellere version
	{
		if (y0 > y1)
		{
			dy = y0;
			y0 = y1;
			y1 = dy;
		}
		Pattern = ucLCDPatTab3[x0 % PIXELPERBYTE];
		Addr = y0 * BYTESPERLINE + x0 / PIXELPERBYTE + GRAPHICHOMEADDR;
		if (Mode == LCDSET)	// set funktion
		{
			for(dy = y0;dy <= y1;dy++,Addr += BYTESPERLINE)
			{
				LCDWriteWord(WRITEADDR,Addr);
				LCDWriteByte(DATAWRITE,Pattern | LCDReadByte(DATAREAD));
			}
		} else			// clear funktion
		{
			Pattern = Pattern ^ 0xff;
			for(dy = y0;dy <= y1;dy++,Addr += BYTESPERLINE)
			{
				LCDWriteWord(WRITEADDR,Addr);
				LCDWriteByte(DATAWRITE,Pattern & LCDReadByte(DATAREAD));
			}
		}
		return;		
	}

	if (x0 < x1)		// alle anderen schraegen linien
	{
		LCDDrawPixel(Mode,x0,y0);
		if (y0 > y1)
		{
			dy = y0-y1;
			dx = x1-x0;
			if (dx > dy) i = dx;
			else	     i = dy;
			dz = i >> 1;
			while(i--)
			{
				if (dz < dx ){ dz += dy; x0++; }
				if (dz >= dx){ dz -= dx; y0--; }
				LCDDrawPixel(Mode,x0,y0);   
			}		
		} else
		{
			dx = x1 - x0;
			dy = y1 - y0;
			if (dx > dy) i = dx;
			else	     i = dy;
			dz = i >> 1;
			while(i--)
			{
				if (dz < dx ){ dz += dy; x0++; }
				if (dz >= dx){ dz -= dx; y0++; }
				LCDDrawPixel(Mode,x0,y0);   
			}		
		}
	} else
	{
		LCDDrawPixel(Mode,x1,y1);
		if (y1 > y0)
		{
			dy = y1 - y0;
			dx = x0 - x1;
			if (dx > dy) i = dx;
			else	     i = dy;
			dz = i >> 1;
			while(i--)
			{
				if (dz < dx ){ dz += dy; x1++; }
				if (dz >= dx){ dz -= dx; y1--; }
				LCDDrawPixel(Mode,x1,y1);   
			}		
	
		} else
		{
			dy = y0 - y1;
			dx = x0 - x1;
			if (dx > dy) i = dx;
			else	     i = dy;
			dz = i >> 1;
			while(i--)
			{
				if (dz < dx ){ dz += dy; x1++; }
				if (dz >= dx){ dz -= dx; y1++; }
				LCDDrawPixel(Mode,x1,y1);   
			}		
		}
	}
}

